# 练习 21：文件系统：修改根目录，`chroot`

> 原文：[Exercise 21. Filesystems: changing root directory, chroot](https://archive.fo/h9FWU)

> 译者：[飞龙](https://github.com/wizardforcel)

> 协议：[CC BY-NC-SA 4.0](http://creativecommons.org/licenses/by-nc-sa/4.0/)

> 自豪地采用[谷歌翻译](https://translate.google.cn/)

让我从另一个[维基百科](http://en.wikipedia.org/wiki/Chroot)的引用开始：

> Unix 操作系统上的`chroot`是一个操作，可以为当前正在运行的进程及其进程修改根目录。在这种修改后的环境中运行的程序，不能指定（也就是访问）这个特定目录树之外的文件。术语`chroot`可以指`chroot(2)`系统调用或`chroot(8)`包装程序。修改后的环境称为`chroot`监牢。

这意味着你可以创建一个目录（例如`/opt/root`），将必要的程序复制到那里并执行此程序。对于这样的程序，`/opt/root/`就是根目录`/`。要了解为什么你需要这样，请阅读维基百科[`chroot`](http://en.wikipedia.org/wiki/Chroot%23Uses)文章。

这是练习的时候了。你现在将使用 bash 创建一个最小的`chroot`环境。为此，你将创建一个目录结构，并将 bash 及其依赖项复制到其中。

现在，你将学习如何创建一个`chroot`环境并进入它。

## 这样做

```
 1: sudo -s
 2: ldd /bin/bash
 3: mkdir -vp /opt/root/bin
 4: mkdir -v /opt/root/lib
 5: mkdir -v /opt/root/lib64
 6: cp -v /bin/bash /opt/root/bin/
 7: cp -v /lib/libncurses.so.5 /opt/root/lib/
 8: cp -v /lib/libdl.so.2 /opt/root/lib
 9: cp -v /lib/libc.so.6 /opt/root/lib
10: cp -v /lib64/ld-linux-x86-64.so.2 /opt/root/lib64
11: chroot /opt/root/
```

哇哦，你为你自己创建了一个 Linux，某种程度上是这样。

## 你会看到什么

```
user1@vm1:/opt~ sudo -s
root@vm1:/opt# ldd /bin/bash
        linux-vdso.so.1 =>  (0x00007fff17bff000)
        libncurses.so.5 => /lib/libncurses.so.5 (0x00007f4b1edc6000)
        libdl.so.2 => /lib/libdl.so.2 (0x00007f4b1ebc2000)
        libc.so.6 => /lib/libc.so.6 (0x00007f4b1e85f000)
        /lib64/ld-linux-x86-64.so.2 (0x00007f4b1f012000)
root@vm1:/opt# mkdir -vp /opt/root/bin
mkdir: created directory `/opt/root'
mkdir: created directory `/opt/root/bin'
root@vm1:/opt# mkdir -v /opt/root/lib
mkdir: created directory `/opt/root/lib'
root@vm1:/opt# mkdir -v /opt/root/lib64
mkdir: created directory `/opt/root/lib64'
root@vm1:/opt# cp -v /bin/bash /opt/root/bin/
`/bin/bash' -> `/opt/root/bin/bash'
root@vm1:/opt# cp -v /lib/libncurses.so.5 /opt/root/lib/
`/lib/libncurses.so.5' -> `/opt/root/lib/libncurses.so.5'
root@vm1:/opt# cp -v /lib/libdl.so.2 /opt/root/lib
`/lib/libdl.so.2' -> `/opt/root/lib/libdl.so.2'
root@vm1:/opt# cp -v /lib/libc.so.6 /opt/root/lib
`/lib/libc.so.6' -> `/opt/root/lib/libc.so.6'
root@vm1:/opt# cp -v /lib64/ld-linux-x86-64.so.2 /opt/root/lib64
`/lib64/ld-linux-x86-64.so.2' -> `/opt/root/lib64/ld-linux-x86-64.so.2'
root@vm1:/opt# chroot /opt/root/
```

## 解释

1.  作为超级用户（root）执行 bash。
1.  打印出 bash 需要的的库。
1.  在一个命令中创建`/opt/root/`和`/opt/root/bin/`目录。很帅吧？
1.  创建`/opt/root/lib`目录。
1.  创建`/opt/root/lib64`目录。
1.  将`/bin/bash`复制到`/opt/root/bin/`。
1.  将`/lib/libncurses.so.5`复制到`/opt/root/lib/`。
1.  将`/lib/libdl.so.2`复制到`/opt/root/lib/`。
1.  将`/lib/libc.so.6`复制到`/opt/root/lib/`。
1.  将`/lib64/ld-linux-x86-64.so.2`复制到`/opt/root/lib64/`。
1.  将根目录更改为`/opt/root/`。

## 附加题

+   阅读`man chroot`，`man ldd`。
+   将`ls`命令复制到你的`chroot`并使其正常工作。
+   一个难题：将`vim`复制到你的`chroot`并使其正常工作。
